#include "ctextbutton.h"

CColor LightGrey  = {200, 200, 200, 255};

CTextButton::CTextButton (const CRect& size, CControlListener* listener, long tag, const char* _title)
	: CControl (size, listener, tag)
{
	strcpy (title, _title ? _title : "");
}

void CTextButton::draw (CDrawContext* pContext)
{
	pContext->setFillColor (LightGrey);
	pContext->setFrameColor (kBlackCColor);
	pContext->drawRect (size, kDrawFilledAndStroked);
	pContext->setFont (kNormalFont);
	pContext->setFontColor (kBlackCColor);
	pContext->drawString (title, size);
}

void CTextButton::mouse (CDrawContext *pContext, CPoint &where, long button)
{
	if (listener)
		listener->valueChanged (pContext, this);
}

