#include <windows.h>
#include <wininet.h>
#include "mikugo.h"
#include "editor.h"


//-------------------------------------------------------------------------------------------------------
AudioEffect* createEffectInstance (audioMasterCallback audioMaster)
{
	return new Mikugo (audioMaster);
}

//-------------------------------------------------------------------------------------------------------
Mikugo::Mikugo (audioMasterCallback audioMaster) : AudioEffectX (audioMaster, 1, 0)
{
	setNumInputs(0);
	setNumOutputs(0);
	setUniqueID ('Mkgo');
	vst_strncpy (programName, "Default", kVstMaxProgNameLen);

	editor = new Editor(this);
}

//-------------------------------------------------------------------------------------------------------
Mikugo::~Mikugo ()
{
}

//-------------------------------------------------------------------------------------------------------
void Mikugo::setProgramName (char* name)
{
	vst_strncpy (programName, name, kVstMaxProgNameLen);
}

//-----------------------------------------------------------------------------------------
void Mikugo::getProgramName (char* name)
{
	vst_strncpy (name, programName, kVstMaxProgNameLen);
}

//-----------------------------------------------------------------------------------------
void Mikugo::setParameter (VstInt32 index, float value)
{
}

//-----------------------------------------------------------------------------------------
float Mikugo::getParameter (VstInt32 index)
{
	return 0.0;
}

//-----------------------------------------------------------------------------------------
void Mikugo::getParameterName (VstInt32 index, char* label)
{
	vst_strncpy (label, "", kVstMaxParamStrLen);
}

//-----------------------------------------------------------------------------------------
void Mikugo::getParameterDisplay (VstInt32 index, char* text)
{
	dB2string (0.0, text, kVstMaxParamStrLen);
}

//-----------------------------------------------------------------------------------------
void Mikugo::getParameterLabel (VstInt32 index, char* label)
{
	vst_strncpy (label, "", kVstMaxParamStrLen);
}

//------------------------------------------------------------------------
bool Mikugo::getEffectName (char* name)
{
	vst_strncpy (name, "Mikugo", kVstMaxEffectNameLen);
	return true;
}

//------------------------------------------------------------------------
bool Mikugo::getProductString (char* text)
{
	vst_strncpy (text, "Mikugo", kVstMaxProductStrLen);
	return true;
}

//------------------------------------------------------------------------
bool Mikugo::getVendorString (char* text)
{
	vst_strncpy (text, "aikelab.net", kVstMaxVendorStrLen);
	return true;
}

//-----------------------------------------------------------------------------------------
VstInt32 Mikugo::getVendorVersion ()
{ 
	return 1000; 
}

//-----------------------------------------------------------------------------------------
void Mikugo::processReplacing (float** inputs, float** outputs, VstInt32 sampleFrames)
{
}

